package os.io;

import os.session.Session;

/**
 * Interface for input services.
 * 
 * @author Jakub Rinkes, Jan Moulis, Kamil Rendl
 *
 */
public interface InputService {
    
    public final String CHARSET = "UTF-8";
    
    public final int STANDARD = 0;
    public final int FILE = 1;
    public final int PIPE = 2;
    
    String readLine();
    
    int read();
    
    int read(byte[] bytes);
    
    void close();
    
    int getType();
    
    void setSession(Session session);
    
}
