package os.io;

import os.session.Session;

/**
 * Interface for output services.
 * 
 * @author Jakub Rinkes, Jan Moulis, Kamil Rendl
 * 
 */
public interface OutputService {

    public final String CHARSET = "UTF-8";

    public final int STANDARD = 0;
    public final int FILE = 1;
    public final int PIPE = 2;

    void write(String text);

    void write(int c);

    void write(byte[] bytes);

    boolean isErrorService();

    void close();

    int getType();

    void setSession(Session session);

    void shutdown();
}
