package os.process;

import java.util.List;

import os.io.InputService;
import os.io.OutputService;
import os.session.Session;

/**
 * Interface for all proceses.
 * 
 * @author Jakub Rinkes, Jan Moulis, Kamil Rendl
 *
 */
public interface IProcess extends Runnable {

    Session getSession();

    void setSession(Session session);

    void setInput(InputService input);

    void setOutput(OutputService output);

    void setError(OutputService error);

    void setParent(Long parent);

    void addChild(Long child);

    void setChilds(List<Long> childs);

    void setNext(Long next);

    void addArgument(String arg);

    void addParameter(String param);

    String getCommand();

    IProcess getClone();

    List<String> getArgs();

    List<String> getParams();

    Long getParent();

    Long getNext();

    List<Long> getChilds();

    InputService getInput();

    OutputService getOutput();

    OutputService getError();

    Long getPid();

    void setPid(Long pid);

    /**
     * weak copy of process without input/output (used for ps)
     */
    IProcess getWeakCopy();

    void close();

    boolean isProcess(String command);

    void setBackground(boolean background);

    boolean isBackground();

    boolean isShutdown();

    void setShutdown(boolean shutdown);

    void shutdown();

    boolean isLogged();

    void setLogged(boolean logged);

    List<Process> getPipedProcesses();
}
