package os.process;

import os.io.OutputService;

/**
 * Shutdown process - start system shutdown.
 * 
 * @author Jakub Rinkes, Jan Moulis, Kamil Rendl
 * 
 */
public class ShutdownProcess extends Process {

    private static final String COMMAND = "SHUTDOWN";

    public String getCommand() {
        return COMMAND;
    }

    public void run() {

        if (getOutput().getType() != OutputService.PIPE) {

            if (getParams() != null && getParams().size() > 0 || getArgs() != null && getArgs().size() > 0) {
                getError().write("shutdown: invalid option, use 'help shutdown'\n");
                Thread.currentThread().interrupt();
                return;
            }
            
            // if u run shutdown on proceses - everything is interrupted and init end system.
            ProcessManager.get().shutdown();
        }
    }

    public IProcess getClone() {
        return new ShutdownProcess();
    }

    public IProcess getWeakCopy() {
        ShutdownProcess clone = new ShutdownProcess();
        clone.setArguments(getArgs());
        clone.setParameters(getParams());
        clone.setPid(getPid());
        clone.setParent(getParent());
        clone.setChilds(getChilds());
        return clone;
    }

}
