package os.process.shell.exit;

import os.io.OutputService;
import os.process.IProcess;

public class ExitProcess extends os.process.Process {

    private static final String COMMAND = "EXIT";

    public void run() {
        if (getOutput().getType() != OutputService.PIPE) {
            getError().write("exit: wrong use of exit program, use 'help exit'\n");
            Thread.currentThread().interrupt();
            return;
        }
    }

    public String getCommand() {
        return COMMAND;
    }

    public IProcess getClone() {
        return new ExitProcess();
    }

    public IProcess getWeakCopy() {

        ExitProcess clone = new ExitProcess();
        clone.setArguments(getArgs());
        clone.setParameters(getParams());
        clone.setPid(getPid());
        clone.setParent(getParent());
        clone.setChilds(getChilds());
        return clone;

    }

}
