package os.process.shell.pwd;

import os.process.IProcess;
import os.process.Process;

/**
 * Pwd process for show actual directory.
 * 
 * @author Jakub Rinkes, Jan Moulis, Kamil Rendl
 *
 */
public class PwdProcess extends Process{

    private static final String COMMAND = "PWD";
	
	public void run() {
	    
	    // test if command was run without parameters and argumets
	    if(getParams() != null && getParams().size() > 0 || getArgs() != null && getArgs().size() > 0 ){
            getError().write("pwd: invalid option, use 'help pwd'\n");
            close();
            Thread.currentThread().interrupt();
            return;
        }
	    
	    // print actual working directory to output
		getOutput().write(getSession().getDirectory()+"\r\n");
	}

	public String getCommand(){
        return COMMAND;
    }

	public IProcess getClone() {
		return new PwdProcess();
	}

	public IProcess getWeakCopy() {
		PwdProcess clone = new PwdProcess();
        clone.setArguments(getArgs());
        clone.setParameters(getParams());
        clone.setPid(getPid());
        clone.setParent(getParent());
        clone.setChilds(getChilds());
        return clone;
	}
}
